摘要: 实际上原题解中的图非常直观。 一条树边会将树分为两个连通块,如果连接两个连通块的桥的数量是奇数,那么一定会经过这条树边;反之如果为偶数,则一定不会经过这条树边。证明只要关注到起点与终点必须是同一个点即可。 问题转化为对于每条树边,计算连接两个连通块的桥的数量的奇偶性,本质上是树上差分。 阅读全文
posted @ 2026-10-17 13:31 Ginger_he 阅读(4) 评论(0) 推荐(0)
摘要: 由于只关心下标集合,所以我们先对原数组从小到大排序,记为 \(\{b_n\}\)。 若子序列长度为奇数,假设 \(b_l=b_{l+1}=...=b_r=x\),当我们选定中间数,左右两边的数的个数要相等,因此答案为 \(\sum\limits_{i=l}^{r}\sum\limits_{j=0}^ 阅读全文
posted @ 2026-09-28 19:47 Ginger_he 阅读(17) 评论(0) 推荐(0)
该文被密码保护。 阅读全文
posted @ 2023-01-01 22:58 Ginger_he 阅读(0) 评论(0) 推荐(0)
摘要: 本文同步更新于洛谷博客 题目描述 给定一张无向图,要求如果 \(A\) 与 \(B\) 之间有边,\(B\) 与 \(C\) 之间有边,那么 \(A\) 与 \(C\) 之间也需要有边,问这张图是否满足要求。 题解 不难发现,如果一个连通块满足上述条件,那它一定是一个完全图。而一个完全图又需要满足 阅读全文
posted @ 2022-05-27 00:10 Ginger_he 阅读(98) 评论(0) 推荐(0)
摘要: 本文同步更新于洛谷博客 题目描述 给定平面直角坐标系上的四个点,作一个正方形使得这 \(4\) 个点分别在正方形每条边所在的直线上。 题解 补充一下 ternary_tree 的证明,好像还挺简单的。 过 \(A\) 作 \(AM\perp BS\) 交 \(BS\) 于点 \(M\),过 \(C\ 阅读全文
posted @ 2022-05-01 09:24 Ginger_he 阅读(105) 评论(0) 推荐(0)
摘要: 本文同步更新于洛谷博客 前置知识 若 \(a\leqslant b,x\leqslant a\),则 \(x\leqslant b\) 若 \(a\geqslant b,x\geqslant a\),则 \(x\geqslant b\) 若 \(a>b,x\geqslant a,x\leqslant 阅读全文
posted @ 2022-04-03 21:54 Ginger_he 阅读(126) 评论(0) 推荐(0)
摘要: 本文同步更新于洛谷博客 题目描述 使用给定的数字,组成一些在 \([A,B]\) 之间的数使得这些数每个都能被 \(X\) 整除。 题解 对于 \(X>10^5\),我们可以直接枚举 \(X\) 的倍数,然后判断其是否符合条件。 对于 \(X\leqslant10^5\),则使用数位 dp。我们传四 阅读全文
posted @ 2022-03-25 21:58 Ginger_he 阅读(98) 评论(0) 推荐(0)
摘要: 本文同步更新于博客园 前言 最优解 \(rank1\),空间吊打 std。 题解 先求出 \(a_i\) 在模 \(k\) 意义下的前缀和,记为 \(s_i\),顺便用桶记录下每种余数出现的次数。 接下来我们 \(O(n)\) 枚举对每个关卡使用 bomb 的答案,假设枚举到第 \(x\) 关。不难 阅读全文
posted @ 2022-03-20 13:45 Ginger_he 阅读(117) 评论(0) 推荐(0)
摘要: 本文同步更新于洛谷博客 题目描述 \(f(x)\) 表示除 \(x\) 本身之外,\(x\) 的最大约数。给定 \(L,R\),求 \(\max\limits_{i=L}^R\{f(i)\}\)。 题解 先感性理解,要让 \(x\) 尽量大,并且让它除 \(1\) 以外的最小约数尽量小,不难想到答案 阅读全文
posted @ 2022-03-19 19:44 Ginger_he 阅读(139) 评论(0) 推荐(0)
摘要: 本文同步更新于洛谷博客 题目描述 你在一张地图上移动,用 \(1/2/3/4\) 来表示左/右/上/下,当前格子上的字母代表着你要进行相应的操作。 R:\(HP\gets\max(0,HP-10)\) Q:\(ST\gets ST+5\) Y:\(DE\gets DE+5\) M:\(HP\gets 阅读全文
posted @ 2022-03-15 19:29 Ginger_he 阅读(70) 评论(0) 推荐(0)